<template>
    <div class="container">
        <div class="row mt-5">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="card-title">Products</h3>

                        <div class="card-tools">
                            <router-link :to="{ name: 'product-create' }" class="btn btn-success">Add New <i class="fas fa-user-plus fa-fw"></i></router-link>
                        </div>
                    </div>
                    <!-- /.card-header -->
                    <div class="card-body table-responsive p-0">
                        <table class="table table-hover">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Name</th>
                                    <th>Modify</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr v-for="product in products" :key="product.id">
                                    <td>{{ product.id }}</td>
                                    <td>{{ product.name | titleText }}</td>
                                    <td>
                                        <router-link v-bind:to="{ name: 'product-edit', params: { id: product.id } }" href="#"><i class="fa fa-edit blue"></i></router-link>
                                        /
                                        <a href="#" @click="deleteProduct(product.id)"><i class="fa fa-trash red"></i></a>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <!-- /.card-body -->
                </div>
                <!-- /.card -->
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                products: {},
                form: new Form({
                    id : '',
                    name : '',
                    desc : '',
                    image : ''
                }),
            }
        },
        methods: {
            loadProducts() {
                axios.get("backend/product").then(({ data }) => (this.products = data.data ));
            },
            onFileChange(e){
                this.form.image = e.target.files[0];
            },
            createProduct(e) {
                const config = {
                    headers: { 'content-type': 'multipart/form-data' }
                }

                let formData = new FormData();

                this.formData.append('name', this.form.name);
                this.formData.append('desc', this.form.desc);
                this.formData.append('image', this.form.image);
                this.$Progress.start();
                axios.post('/backend/product', this.formData, config).then( () => {
                    Fire.$emit('AfterCreate');
                    $('#addNew').modal('hide');
                    toast.fire('Success', 'Product Created Successfully', 'success', 5000);
                    this.$Progress.finish();
                }).catch( ()  => {
                    toast.fire('Failed', 'There was something wrong.', 'failed', 5000);
                    this.$Progress.fail();
                });
            },
            deleteProduct(id){
                swal.fire({
                    title: "Are you sure?",
                    text: "You won't be able to revert this!",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#3085d6",
                    cancelButtonColor: "#d33",
                    confirmButtonText: "Yes, delete it!"
                }).then((result) => {
                    //send result to server
                    if (result.value) {
                        this.form.delete('backend/product/'+id).then(() => {
                            swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            );
                            Fire.$emit('AfterCreate');
                        }).catch(() => {
                            swal.fire(
                                'Failed!',
                                'There was something wrong.',
                                'warning'
                            );
                        });
                    }
                });
            }
        },
        created() {
            this.loadProducts();
            Fire.$on('AfterCreate',() => {
                this.loadProducts();
            });
            console.log('Products Component mounted.');
        }
    }
</script>
